"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createNuxtHandler = createNuxtHandler;

var _serverlessExpress = _interopRequireDefault(require("@vendia/serverless-express"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const {
  Nuxt
} = require('nuxt-start'); // eslint-disable-line


function createNuxtHandler(nuxtConfig) {
  const nuxt = new Nuxt(_objectSpread(_objectSpread({}, nuxtConfig), {}, {
    dev: false,
    _start: true
  }));
  let serverPromise = null;
  return (event, ctx, callback) => {
    if (!serverPromise) {
      serverPromise = Promise.resolve(nuxt === null || nuxt === void 0 ? void 0 : nuxt.ready()).then(() => (0, _serverlessExpress.default)({
        app: nuxt.server.app
      }));
    }

    return serverPromise.then(server => server(event, ctx, callback));
  };
}